AOZ Studio Beta - Bug #348

A user defined function cannot call another user-defined function. (Causes internal error or program

freeze.)
04/18/2020 06:54 PM - Brian Flanagan

Start date: 04/18/2020
Due date:

% Done: 0%
Estimated time: 2:00 hours

Status: Feedback
Priority: High
Assignee: Francois Lionet
Category:

Target version: 1.0.0 (B3)
Affected version: 1.0.0 (B3)
Description

Example:

/

Leap Year: Brian Flanagan

Parameter: vy 4-digit year

Returns: Leap Year (l=leap, O=not) '
=
Function "LeapYear",y
1ly=0
If y=4*Int(y/4) Then ly=1
If y=100*Int (y/100) Then 1ly=0
If y=400*Int (y/400) THen ly=1
End Function (ly)
/*
Parameters: y 4-digit year
m month (1-12)
d day of month (1-31)
Returns: Day of year.
Y
Function "DayOfYear", y, m, d

doy=Int (3055* (m+2) /100)-91
If m>2 Then doy=doy-2+LeapYear (y)
doy=doy+d

End Function (doy)

Print DayOfYear(2020,1,31),DayOfYear(2020,4,18)

Result in this instance is an Internal Error.

Yes, there's a reason for 0 or 1

History

#1 - 07/03/2020 11:05 PM - Brian Flanagan
- Affected version changed from 0.9.8.1 to 0.9.9.3

Retested in 0.9.9.3. Problem still exists. Causes program freeze.

#2 - 08/30/2020 01:29 PM - Francois Lionet
- Status changed from New to Resolved
- Assignee set to Francois Lionet

- Target version set to 0.9.9.4-r2

Fixed!

#3 - 10/04/2020 12:32 PM - Brian Flanagan

- Status changed from Resolved to Feedback
Tested in Beta RC3. Still broken.

Non-dimensioned array in line 21. LeapYear function is not recognized inside DayOfYear.

#4 - 10/08/2020 05:08 AM - Francois Lionet

- Status changed from Feedback to Resolved

- Target version changed from 0.9.9.4-r2 to Beta RC4

Fixed in RC4.

#5 - 10/09/2020 03:05 PM - Brian Flanagan

- Status changed from Resolved to Feedback

-Es

timated time set to 2:00 h

After the 9 Oct updates, it no longer gets an internal error, however there is still a problem.
It may or may not be a related issue.

Using the same example code above, printing out the function results individually works, however, making multiple calls to the function in a single

print statement gives unpredictable results. Example:

/*
Leap Year: Brian Flanagan
Parameter: vy 4-digit year
Returns: Leap Year (l=leap, O=not)
=y
Function "LeapYear",y

End

/*

*/

Fun

1ly=0

If y=4*Int(y/4) Then ly=1

If y=100*Int(y/100) Then ly=0
If y=400*Int (y/400) THen ly=1
Function (ly)

Parameters: y 4-digit year

m month (1-12)

d day of month (1-31)
Returns: Day of year.

ction "DayOfYear", y, m, d
doy=Int (3055* (m+2)/100)-91

If m>2 Then doy=doy-2+LeapYear (y)
doy=doy+d

there's a reason for 0 or 1

End Function (doy)

// NOTE: All of the function calls work *individually*

Print DayOfYear (2020,1,31) ' Works (31)

Print DayOfYear (2020,2,29) ' Works (60)

Print DayOfYear (2020,3,3) ' Works (63)

Print DayOfYear (2020,4,18) ' Works (109)

Print DayOfYear (2020,12,31) ' Works (366)

// .but not when multiple items are printed on the same line.

Print DayOfYear (2020,1,31),DayOfYear (2020,1,31) ' Both work.

Print DayOfYear (2020,1,31),DayOfYear (2020,4,18) ' Works 2nd x only. (wrong result on lst)

Print DayOfYear (2020,1,31),DayOfYear (2020,12,31) ' Works 2nd x only. (wrong result on lst)

Print DayOfYear (2020,1,31),DayOfYear (2020,12,31),DayOfYear(4,18) ' Works 2nd x only (wrong result on 1lst, 3rd
x = NaN)

Print DayOfYear (2020,1,31),DayOfYear (2020,2,29),DayOfYear (2020,4,18),DayOfYear (2020,12,31) ' Wrong result on 1

st

Print DayOfYear (2020,1,31),DayOfYear (2020,2,29),DayOfYear (2020,4,18),DayOfYear (2020,12,31),DayOfYear (2020, 3, 3)

#6 -

Wrong result on 1lst

02/14/2021 04:29 AM - Brian Flanagan

- Affected version changed from 0.9.9.3 to 1.0.0 (B3)

This was partially fixed before, however, it is now completely broken again.

Newest test was in 1.0.0 B3 (2/12/2021).

Exal

mple:
Function "Numberls$"
End Function ("one")

Function "Number2s$"
End Function (Numberl$+" two")

Print "Numberl: ";Numberl$ // This works (by itself - you'll have to comment the last line)
Print "Number2: ";Number2$ // Should print "one two", but fails.

#7 - 02/14/2021 04:29 AM - Brian Flanagan
- Target version changed from Beta RC4 to 1.0.0 (B3)

#8 - 02/14/2021 04:30 AM - Brian Flanagan
- Priority changed from Normal to High
